/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.mospcommon.system.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.google.appengine.api.datastore.Query;

import jp.getset.gae.bigtable.PreparedStatement;
import jp.getset.gae.bigtable.option.PreparedProperty;
import jp.getset.gae.bigtable.option.operation.OperationMax;
import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.mospcommon.system.dto.CmAgreementWorkOnDto;

/**
 * CM_AGREEMENT_WORK_ON(休出協定マスタ)のDAOクラス 。
 */
public class CmAgreementWorkOnDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * CM_AGREEMENT_WORK_ON(休出協定マスタ)。
	 */
	public static final String	TABLE						= "CM_AGREEMENT_WORK_ON";
	
	/**
	 * KEY_1 = WORK_ON_ID(休出協定ID)。
	 */
	public static final String	KEY_1						= "WORK_ON_ID";
	
	// 列名
	/**
	 * WORK_ON_ID(休出協定ID)。
	 */
	public static final String	COL_WORK_ON_ID				= "WORK_ON_ID";
	/**
	 * WORK_ON_CODE(休出協定コード)。
	 */
	public static final String	COL_WORK_ON_CODE			= "WORK_ON_CODE";
	/**
	 * WORK_TYPE_NAME(業務の種類)。
	 */
	public static final String	COL_WORK_TYPE_NAME			= "WORK_TYPE_NAME";
	/**
	 * CAUSE(具体的事由)。
	 */
	public static final String	COL_CAUSE					= "CAUSE";
	/**
	 * STANDARD_WEEK_HOLIDAY(所定休日)。
	 */
	public static final String	COL_STANDARD_WEEK_HOLIDAY	= "STANDARD_WEEK_HOLIDAY";
	/**
	 * OFFICIAL_HOLIDAY(法定休日)。
	 */
	public static final String	COL_OFFICIAL_HOLIDAY		= "OFFICIAL_HOLIDAY";
	/**
	 * JAPANESE_HOLIDAY_FLAG(国民の祝日フラグ)。
	 */
	public static final String	COL_JAPANESE_HOLIDAY_FLAG	= "JAPANESE_HOLIDAY_FLAG";
	/**
	 * HOLIDAY_MASTER_FLAG(祝祭日マスタフラグ)。
	 */
	public static final String	COL_HOLIDAY_MASTER_FLAG		= "HOLIDAY_MASTER_FLAG";
	/**
	 * STANDARD_HOLIDAY_RATE(所定休日割増賃金率)。
	 */
	public static final String	COL_STANDARD_HOLIDAY_RATE	= "STANDARD_HOLIDAY_RATE";
	/**
	 * OFFICIAL_HOLIDAY_RATE(法定休日割増賃金率)。
	 */
	public static final String	COL_OFFICIAL_HOLIDAY_RATE	= "OFFICIAL_HOLIDAY_RATE";
	/**
	 * NUMBER_OF_WORK_ON(休出日数)。
	 */
	public static final String	COL_NUMBER_OF_WORK_ON		= "NUMBER_OF_WORK_ON";
	/**
	 * START_TIME(開始時刻)。
	 */
	public static final String	COL_START_TIME				= "START_TIME";
	/**
	 * END_TIME(終了時刻)。
	 */
	public static final String	COL_END_TIME				= "END_TIME";
	/**
	 * START_DATE(開始年月日)。
	 */
	public static final String	COL_START_DATE				= "START_DATE";
	/**
	 * DELETE_FLAG(削除フラグ)。
	 */
	public static final String	COL_DELETE_FLAG				= "DELETE_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public CmAgreementWorkOnDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<CmAgreementWorkOnDto> mappingAll() throws SQLException {
		List<CmAgreementWorkOnDto> all = new ArrayList<CmAgreementWorkOnDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return CM_AGREEMENT_WORK_ONレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private CmAgreementWorkOnDto mapping() throws SQLException {
		CmAgreementWorkOnDto dto = new CmAgreementWorkOnDto();
		dto.setWorkOnId(rs.getInt(COL_WORK_ON_ID));
		dto.setWorkOnCode(rs.getString(COL_WORK_ON_CODE));
		dto.setWorkTypeName(rs.getString(COL_WORK_TYPE_NAME));
		dto.setCause(rs.getString(COL_CAUSE));
		dto.setStandardWeekHoliday(rs.getString(COL_STANDARD_WEEK_HOLIDAY));
		dto.setOfficialHoliday(rs.getString(COL_OFFICIAL_HOLIDAY));
		dto.setJapaneseHolidayFlag(rs.getString(COL_JAPANESE_HOLIDAY_FLAG));
		dto.setHolidayMasterFlag(rs.getString(COL_HOLIDAY_MASTER_FLAG));
		dto.setStandardHolidayRate(rs.getInt(COL_STANDARD_HOLIDAY_RATE));
		dto.setOfficialHolidayRate(rs.getInt(COL_OFFICIAL_HOLIDAY_RATE));
		dto.setNumberOfWorkOn(rs.getInt(COL_NUMBER_OF_WORK_ON));
		dto.setStartTime(rs.getInt(COL_START_TIME));
		dto.setEndTime(rs.getInt(COL_END_TIME));
		dto.setStartDate(rs.getDate(COL_START_DATE));
		dto.setDeleteFlag(rs.getInt(COL_DELETE_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementWorkOnDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得。
	 * @param workOnId 休出協定ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementWorkOnDto findForKey(int workOnId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, workOnId);
			executeQuery();
			CmAgreementWorkOnDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得。
	 * @param workOnId 休出協定ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementWorkOnDto findForUpdate(int workOnId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, workOnId);
			executeQuery();
			CmAgreementWorkOnDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param workOnId 休出協定ID
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementWorkOnDto> findForCondition(int workOnId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_WORK_ON_ID);
		sb.append(" = ? ");
		this.pob.appendWhere(COL_WORK_ON_ID, Query.FilterOperator.EQUAL);
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, workOnId);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param workOnCode 休出協定コード
	 * @param workTypeName 業務の種類
	 * @param deleteFlag 削除フラグ
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementWorkOnDto> findForCondition(String workOnCode, String workTypeName, String deleteFlag)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_WORK_ON_CODE);
		sb.append(" LIKE ? AND ");
		sb.append(COL_WORK_TYPE_NAME);
		sb.append(" LIKE ? ");
		this.pob.appendLike(COL_WORK_ON_CODE);
		this.pob.appendLike(COL_WORK_TYPE_NAME);
		if (!deleteFlag.equals("")) {
			sb.append("AND ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ? ");
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL);
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, workOnCode + "%");
			setParam(index++, "%" + workTypeName + "%");
			if (!deleteFlag.equals("")) {
				setParam(index++, Integer.parseInt(deleteFlag));
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param workOnCode 休出協定コード
	 * @param targetDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementWorkOnDto findForAgreement(String workOnCode, Date targetDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_WORK_ON_CODE);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" <= ? ");
			sb.append(getOrderBy());
			sb.append(COL_START_DATE);
			sb.append(" ");
			sb.append(getDesc());
			sb.append(getLimit());
			sb.append("1");
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
			this.pob.appendWhere(COL_WORK_ON_CODE, Query.FilterOperator.EQUAL);
			this.pob.appendWhere(COL_START_DATE, Query.FilterOperator.LESS_THAN_OR_EQUAL);
			this.pob.appendSort(COL_START_DATE, Query.SortDirection.DESCENDING);
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			this.pob.setLimit(1);
			setParam(index++, workOnCode);
			setParam(index++, targetDate);
			executeQuery();
			CmAgreementWorkOnDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param workOnCode 休出協定コード
	 * @param targetDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementWorkOnDto findForStartDate(String workOnCode, Date targetDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_WORK_ON_CODE);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" = ? ");
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
			this.pob.appendWhere(COL_WORK_ON_CODE, Query.FilterOperator.EQUAL);
			this.pob.appendWhere(COL_START_DATE, Query.FilterOperator.EQUAL);
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, workOnCode);
			setParam(index++, targetDate);
			executeQuery();
			CmAgreementWorkOnDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * max値取得
	 * @return String　最大連番
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public String findForMax() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			String max = "";
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT MAX(");
			sb.append(COL_WORK_ON_ID);
			sb.append(") FROM ");
			sb.append(TABLE);
			// GAE
			this.setPreparedStatement(PreparedStatement.Mode.SELECT, getClass());
			PreparedProperty operation = new PreparedProperty(COL_WORK_ON_ID);
			operation.setOperation(new OperationMax());
			this.pob.appendFilledPreparable(operation);
			
			prepareStatement(sb.toString());
			executeQuery();
			if (rs.next()) {
				max = String.valueOf(rs.getLong(1));
			}
			return max;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 休出協定コード取得
	 * @param targetDate 対象年月日
	 * @return 検索結果
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<String> findForWorkOnCode(Date targetDate) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT DISTINCT ");
			sb.append(COL_WORK_ON_CODE);
			sb.append(" FROM ");
			sb.append(TABLE);
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" <= ?");
			// GAE
			this.setPreparedStatement(PreparedStatement.Mode.SELECT, getClass());
			this.pob.appendDistinct(COL_WORK_ON_CODE);
			this.pob.appendWhere(COL_DELETE_FLAG, Query.FilterOperator.EQUAL, MospConst.DELETE_FLAG_OFF);
			this.pob.appendWhere(COL_START_DATE, Query.FilterOperator.LESS_THAN_OR_EQUAL);
			prepareStatement(sb.toString());
			setParam(index++, targetDate);
			executeQuery();
			List<String> list = new ArrayList<String>();
			while (rs.next()) {
				list.add(rs.getString(COL_WORK_ON_CODE));
			}
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入。
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(CmAgreementWorkOnDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新。
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(CmAgreementWorkOnDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getWorkOnId());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除。
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(CmAgreementWorkOnDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getWorkOnId());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private void setParams(CmAgreementWorkOnDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getWorkOnId());
		setParam(index++, dto.getWorkOnCode());
		setParam(index++, dto.getWorkTypeName());
		setParam(index++, dto.getCause());
		setParam(index++, dto.getStandardWeekHoliday());
		setParam(index++, dto.getOfficialHoliday());
		setParam(index++, dto.getJapaneseHolidayFlag());
		setParam(index++, dto.getHolidayMasterFlag());
		setParam(index++, dto.getStandardHolidayRate());
		setParam(index++, dto.getOfficialHolidayRate());
		setParam(index++, dto.getNumberOfWorkOn());
		setParam(index++, dto.getStartTime());
		setParam(index++, dto.getEndTime());
		setParam(index++, dto.getStartDate());
		setParam(index++, dto.getDeleteFlag());
		setCommonParams(isInsert);
	}
	
}
